<?php
require_once(realpath(dirname(__FILE__)) . '/Forfaitzonequantite.class.php');
require_once(realpath(dirname(__FILE__)) . "/../../../classes/Variable.class.php");

@include_once(realpath(dirname(__FILE__)) . "/../../../fonctions/authplugins.php");
if (function_exists('autorisation')) autorisation(ForfaitZoneQuantite::MODULE_NAME);

class FzqAdmin extends ForfaitZoneQuantite
{
	public $redirect;

	public $zones;
	public $depts_zone;
	public $depts_dispo;
	public $type_calcul;

	public $labels;

	public $id_zone;

	public $erreur;

	public $test_resultat;
	public $test_quantite;
	public $test_departement;

	function FzqAdmin($id_zone = -1)
	{
		$this->redirect = false;

		$this->zones = array();
		$this->depts_zone  = array();
		$this->depts_dispo = array();

		$this->id_zone = $id_zone;

		$this->test_resultat = false;

		// Mode de fonctionnement
		$this->type_calcul = $this->get_variable('fzq_mode_calcul');
	}

	// Create zone
	function create_or_update_zone()
	{
		$id_zone = intval($_REQUEST['_fzq_id_zone']);

		if ($id_zone == -1)
		{
			$this->_query("insert into fzq_zones (nom) values ('".$this->escape($_REQUEST['_fzq_nom_zone'])."')");

			$id_zone = mysql_insert_id();
		}
		else
		{
			$this->_query("update fzq_zones set nom = '".$this->escape($_REQUEST['_fzq_nom_zone'])."' where id=$id_zone");

			$this->_query("delete from fzq_def_zones where id_zone=$id_zone");
		}

		$values = "";

		foreach($_REQUEST['_fzq_dept_zone'] as $dep)
		{
			$values .= ($values == '' ? '':',') . "($id_zone, '".$this->escape($dep)."')";
		}

		if ($values != '')
		{
			$this->_query("insert into fzq_def_zones (id_zone, departement) values $values");
		}

		$this->redirect = true;
	}

	function delete_zone()
	{
		$id_zone = intval($_REQUEST['_fzq_id_zone']);

		$this->_query("delete from fzq_zones where id=$id_zone");
		$this->_query("delete from fzq_def_zones where id_zone=$id_zone");

		$this->redirect = true;
	}

	function create_dept()
	{
		$id_dept = $this->escape($_REQUEST['_fzq_id_departement']);
		$nom_dept = $this->escape($_REQUEST['_fzq_nom_departement']);

		$this->_query("insert into fzq_departements (id, nom) values ('$id_dept', '$nom_dept')");

		$this->redirect = true;
	}

	function delete_dept()
	{
		if ($_REQUEST['_fzq_delete_all'] == '1')
		{
			$this->_query("truncate table fzq_departements");
			$this->_query("truncate table fzq_def_zones");
		}
		else
		{
			$dept_id = $this->escape($_REQUEST['_fzq_del_dept']);

			$this->_query("delete from fzq_departements where id='$dept_id'");

			// Supprimer des zones
			$this->_query("delete from fzq_def_zones where departement='$dept_id'");
		}

		$this->redirect = true;
	}

	function create_tarif()
	{
		try
		{
			$query = "
                insert into
                    fzq_data
                (id_zone, quantite_max, forfait, surcout_unitaire, mode_surcout)
                values (
                    ".$this->escape($_REQUEST['id_zone_data_new']).",
                    ".$this->escape($_REQUEST['quantite_maxi_new']).",
                    ".$this->escape($_REQUEST['tarif_new']).",
                    ".$this->escape($_REQUEST['surcout_unitaire_new']).",
                    '".$this->escape($_REQUEST['mode_surcout_new'])."'
                    )";

			$this->_query($query);
		}
		catch (Exception $ex)
		{
			$this->erreur = $ex->getMessage();
		}
	}

	function detete_tarif()
	{
		$id_data = intval($_REQUEST['_fzq_id_data']);

		$this->_query("delete from fzq_data where id=$id_data");
	}

	function update_tarif()
	{
		$this->_query("delete from fzq_data");

		$idx = 0;

		foreach($_REQUEST['id_zone_data'] as $id)
		{
			$this->_query("
                insert into fzq_data
                	(id_zone, quantite_max, forfait, surcout_unitaire, mode_surcout)
                values
                	($id,
                	 ".$this->escape($_REQUEST['quantite_maxi'][$idx]).",
                	 ".$this->escape($_REQUEST['tarif'][$idx]).",
                     ".$this->escape($_REQUEST['surcout_unitaire'][$idx]).",
                     '".$this->escape($_REQUEST['mode_surcout'][$idx])."'
                 )"
            ); 

           	$idx++;
		}
	}

	function prepare_update()
	{
		$this->id_zone = intval($_REQUEST['_fzq_id_zone']);
	}

	function test_tarif()
	{
		$this->test_quantite = $this->escape($_REQUEST['test_quantite']);
		$this->test_departement = $this->escape($_REQUEST['test_departement']);

		$this->test_resultat = $this->trouver_tarif($this->test_quantite, $this->test_departement);
	}

	function changer_parametres()
	{
        foreach($_REQUEST as $var => $value)
        {
            if (! preg_match('/^'.ForfaitZoneQuantite::PREFIXE.'/', $var)) continue;

            $this->delete_variable($var);
            $this->create_variable($var, $value);
        }

        // Bug 1.4.3.1
        if (class_exists('CacheBase')) CacheBase::getCache()->reset_cache();

        $this->redirect = true;
	}

	function prepare_main_page()
	{
		// Bug 1.4.3.1
        if (class_exists('CacheBase')) CacheBase::getCache()->reset_cache();

		if ($this->redirect)
		{
			?>
			<script type="text/javascript">
				window.location = "<?php echo $_SERVER['PHP_SELF']; ?>?nom=<?php echo ForfaitZoneQuantite::MODULE_NAME ?>";
			</script>
			</body>
			</html>
			<?php

			exit();
		}

		if ($this->type_calcul == 'poids')
		{
			$this->labels['label_maxi'] = 'Jusqu\'au poids (Kg)';
			$this->labels['label_unite'] = 'Kg';
			$this->labels['titre_saisie_tarifs'] = 'TARIFS PAR ZONE ET PAR POIDS';
			$this->labels['label_test'] = 'Poids du panier (Kg)';
			$this->labels['err_val_maxi'] = 'Indiquez un poids maximum valide';
			$this->labels['err_surcout'] = 'Indiquez un surcout par Kg valide';
		}
		else if ($this->type_calcul == 'quantite')
		{
			$this->labels['label_maxi'] = 'Jusqu\'à la quantité';
			$this->labels['label_unite'] = 'unité';
			$this->labels['titre_saisie_tarifs'] = 'TARIFS PAR ZONE ET PAR QUANTITE';
			$this->labels['label_test'] = 'Nombre d\'articles';
			$this->labels['err_val_maxi'] = 'Indiquez une quantité maximum valide';
			$this->labels['err_surcout'] = 'Indiquez un surcout unitaire valide';
		}
		else
		{
			$this->labels['label_maxi'] = 'Jusqu\'au montant (&euro;)';
			$this->labels['label_unite'] = 'euro';
			$this->labels['titre_saisie_tarifs'] = 'TARIFS PAR ZONE ET PAR MONTANT';
			$this->labels['label_test'] = 'Montant total du panier (en Euros)';
			$this->labels['err_val_maxi'] = 'Indiquez un montant maximum valide';
			$this->labels['err_surcout'] = 'Indiquez un surcout par Euro valide';
		}

		// Zones définies
		$query = "
            select z.id, dz.departement, z.nom
            from
                fzq_zones z
            left join
                fzq_def_zones dz on dz.id_zone = z.id
            order by
                z.nom, dz.departement";

		$zones_tmp = $this->query_to_array($query);

		$curr = 0;
		$depts = "";
		$this->zones = array();

		foreach($zones_tmp as $zone)
		{
			if ($zone['id'] != $curr)
			{
				if ($curr != 0) $this->zones[$curr]['departements'] = $depts;

				$depts = "";

				$curr = $zone['id'];

				$this->zones[$curr]['id'] = $curr;
				$this->zones[$curr]['nom'] = $zone['nom'];
			}

			$depts .= ($depts == '' ? '':', ') . $zone['departement'];
		}

		if ($curr != 0)
		{
			$this->zones[$curr]['departements'] = $depts;
		}

		// Tous les départements
		$query = "
            select *
            from
                fzq_departements
            order by
                id";

		$this->depts_tous = $this->query_to_array($query);

		// Departements disponibles (hors zones)
		$query = "
            select *
            from
                fzq_departements
            where
                (id not in (select departement from fzq_def_zones) )
            order by
                id";

		$this->depts_dispo = $this->query_to_array($query);

		// Departements dans la zone courante
		if ($this->id_zone != -1)
		{
			$query = "
                select *
                from
                    fzq_departements
                where
                    (id in (select departement from fzq_def_zones where id_zone=".$this->id_zone.") )
                order by
                    id";

			$this->depts_zone = $this->query_to_array($query);
		}

		// Les données
		$query = "
            select d.*, z.nom
            from
                fzq_data d, fzq_zones z
            where
                z.id = d.id_zone
            order by
                z.nom, d.quantite_max";

		$this->data = $this->query_to_array($query);
	}
}
?>
