<?php
header("Content-type: text/html;charset=utf-8");

require_once(realpath(dirname(__FILE__)) . '/FzqAdmin.class.php');

// -- MAIN -------------------------------------------------------------------------------------

$adm = new FzqAdmin();

$command = isset($_REQUEST['_fzq_command']) ? $_REQUEST['_fzq_command'] : '';

switch($command)
{
	case 'tarif.new' :
		$adm->create_tarif();
		break;

	case 'tarif.delete' :
		$adm->detete_tarif();
		break;

	case 'tarif.change' :
		$adm->update_tarif();
		break;
}

$adm->prepare_main_page();

?>

<a name="tarifs"></a>
<form method="post" action="#" id="fzq_data_form">
	<table cellspacing="0" cellpadding="0" width="100%"
		style="margin-top: 20px;">
		<tr>
			<th colspan="6">
			<div class="entete_liste">
				<div class="titre"><?php echo $adm->labels['titre_saisie_tarifs']; ?></div>
				<div class="fonction_valider"><a onclick="fzq_maj_tarifs(); return false;" href="#">VALIDER LES MODIFICATIONS</a></div>
			</div>
			</th>
		</tr>

		<?php if ($adm->erreur)
		echo '<tr><th colspan="6"><div style="color: red; font-weight: bold">'.$adm->erreur.'</div></th></tr>';
		?>

		<tr>
			<th class="fzq">Zone</th>
			<th class="fzq"><?php echo $adm->labels['label_maxi']; ?></th>
			<th class="fzq">Forfait</th>
			<th class="fzq">Supplément par <?php echo $adm->labels['label_unite']; ?></th>
			<th class="fzq">Actions</th>
		</tr>

		<?php
		$idx = 0;

		foreach($adm->data as $data)
		{
			$class = "cellule_" . ( ($idx++ % 2) == 0 ? "claire" : "sombre");
			$id = $data['id'];
			?>
		<tr>
			<td class="<?php echo($class); ?>"><select
				name="id_zone_data[]">
				<option value="-1">Choisissez une zone...</option>
				<?php foreach($adm->zones as $zone)
				{
					echo '<option value="'.$zone['id'].'"'.($data['id_zone']==$zone['id'] ? ' selected="selected"':'').'>'.$zone['nom'].'</option>';
				}
				?>
			</select></td>
			<td class="<?php echo($class); ?>">
				<input type="text" name="quantite_maxi[]" size="5" value="<?php echo($data['quantite_max']); ?>" /></td>
			<td class="<?php echo($class); ?>">
				<input type="text" name="tarif[]" size="6" value="<?php echo(sprintf("%01.2f", $data['forfait'])); ?>" /></td>
			<td class="<?php echo($class); ?>">
				<input type="text" name="surcout_unitaire[]" size="6" value="<?php echo(sprintf("%01.2f",$data['surcout_unitaire'])); ?>" />
				<select name="mode_surcout[]">
					<option value="fix" <?php echo($data['mode_surcout'] == 'fix' ? 'selected="selected"' : ''); ?>>Euros</option>
					<option value="pcent" <?php echo($data['mode_surcout'] == 'pcent' ? 'selected="selected"' : ''); ?>>% du forfait</option>
				</select>
			</td>
			<td class="<?php echo($class); ?>">
				<a href="#" onclick="fzq_delete_tarif(<?php echo($id); ?>); return false;">SUPPRIMER</a>
			</td>
		</tr>
		<?php } ?>

		<tr>
			<th class="fzq" colspan="6">NOUVEAU TARIF</th>
		</tr>

		<tr>
			<td class="cellule_claire"><select name="id_zone_data_new">
				<option value="-1">Choisissez une zone...</option>
				<?php foreach ($adm->zones as $zone)
				{
					echo '<option value="'.$zone['id'].'">'.$zone['nom'].'</option>';
				}
				?>
			</select></td>
			<td class="cellule_claire">
				<input type="text" name="quantite_maxi_new" size="5" /></td>
			<td class="cellule_claire">
				<input type="text" name="tarif_new" size="6" /></td>
			<td class="cellule_claire">
				<input type="text" name="surcout_unitaire_new" size="6" />
				<select name="mode_surcout_new">
					<option value="fix">Euros</option>
					<option value="pcent">% du forfait</option>
				</select>

			</td>
			<td class="cellule_claire">
				<a href="#" onclick="fzq_add_tarif(); return false;">+ AJOUTER</a></td>
		</tr>

	</table>
</form>
