<?php
/*************************************************************************************/
/*                                                                                   */
/*      Thelia - Plugin Forfait par zone                                		 	 */
/*                                                                                   */
/*      Copyright (c) Franck Allimant, 2010	                                     	 */
/*		email : thelia@allimant.org 	        	                             	 */
/*      web : http://www.allimant.org                                                */
/*                                                                                   */
/*      This program is free software; you can redistribute it and/or modify         */
/*      it under the terms of the GNU General Public License as published by         */
/*      the Free Software Foundation; either version 2 of the License, or            */
/*      (at your option) any later version.                                          */
/*                                                                                   */
/*      This program is distributed in the hope that it will be useful,              */
/*      but WITHOUT ANY WARRANTY; without even the implied warranty of               */
/*      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                */
/*      GNU General Public License for more details.                                 */
/*                                                                                   */
/*      You should have received a copy of the GNU General Public License            */
/*      along with this program; if not, write to the Free Software                  */
/*      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA    */
/*                                                                                   */
/*************************************************************************************/

require_once(realpath(dirname(__FILE__)) . '/FzqAdmin.class.php');

// -- MAIN -------------------------------------------------------------------------------------

$adm = new FzqAdmin();

$command = $_REQUEST['_fzq_command'];

$id_zone = -1;

switch($command)
{
	case 'create_dept' :
		$adm->create_dept();
		break;

	case 'delete_dept' :
		$adm->delete_dept();
		break;

	case 'create_or_update' :
		$adm->create_or_update_zone();
		break;

	case 'delete' :
		$adm->delete_zone();
		break;

	case 'prepare_update' :
		$adm->prepare_update();
		break;

	case 'new' :
		// Go back to empty page
		$adm->redirect = 1;
		break;

	case 'mode_calcul.change' :
		$adm->changer_parametres();
		break;
}

$adm->prepare_main_page();

?>

<style type="text/css">
td {
	height: 30px;
	padding: 4px;
}

th {
	height: 30px;
}

th.fzq {
	padding: 4px;
	font-weight: bold;
	background-color: #9EB0BE;
}

.fonction_valider {
	float: right;
}
</style>

<script type="text/javascript" src="../lib/jquery/jquery.js"></script>
<script type="text/javascript" src="../client/plugins/<?php echo ForfaitZoneQuantite::MODULE_NAME ?>/js/jquery.selectboxes.pack.js"></script>

<script type="text/javascript">

	var ajax_tarifs_url = '../client/plugins/forfaitzonequantite/admin_tarifs.php';
	var ajax_test_url = '../client/plugins/forfaitzonequantite/admin_test.php';

    function fzq_select_copy(from, to)
    {
        try
        {
            var left = $(from);
            var right = $(to);

            if (left.selectedOptions().length == 0) return;

            left.copyOptions(right);
            left.removeOption(left.selectedValues());

            right.sortOptions();
        }
        catch (ex)
        {
            alert("Erreur: " + ex);
        }
    }

    function fzq_delete(id_zone)
    {
        if (confirm("Supprimer cette zone et tous les tarifs associés ?"))
        {
            $("[name=_fzq_id_zone]").val(id_zone);
            $("#fzq_def_command").val("delete");

            $('#fzq_form').submit();
        }
    }

    function fzq_prepare_update(id_zone)
    {
         $("[name=_fzq_id_zone]").val(id_zone);
         $("#fzq_def_command").val("prepare_update");

        $('#fzq_form').submit();
    }

    function fzq_new_zone(id_zone)
    {
         $("#fzq_def_command").val("new");

        $('#fzq_form').submit();
    }

    function fzq_submit()
    {
        var nz = $('[name=_fzq_nom_zone]').val();

        if (nz == '')
        {
            alert("Merci d'indiquer un nom de zone");

            $('[name=_fzq_nom_zone]').focus();

            return false;
        }

        $("#dept_zone").selectOptions(/.*/);

        if ($("#dept_zone").selectedValues().length == 0)
        {
            alert("Une zone doit contenir au moins un département.");

            $("#depts_dispos").focus();

            return false;
        }

        $('#fzq_form').submit();
    }


    function fzq_dept_submit()
    {
        var test = $('[name=_fzq_nom_departement]').val();

        if (test == '')
        {
            alert("Merci d'indiquer un nom de département (exemple: Haute Garonne)");

            $('[name=_fzq_nom_departement]').focus();

            return false;
        }

        test = $('[name=_fzq_id_departement]').val();

        if (test == '')
        {
            alert("Merci d'indiquer un numéro de departement ou un code postal (exemples: 2A, 31, 31200, 75009...)");

            $('[name=_fzq_id_departement]').focus();

            return false;
        }

        $('#fzq_dept_form').submit();
    }

    function fzq_del_dept_submit()
    {
        if ($('[name=_fzq_delete_all]').attr('checked'))
        {
            if (confirm("Supprimer définitivement tous les départements ?"))
            {
                $('#fzq_del_dept_form').submit();
            }
        }
        else
        {
            var label = $('[name=_fzq_del_dept]').val();

            if (confirm("Supprimer définitivement le département " + label + " ?\nIl sera retiré de toutes les zones où il était présent."))
            {
                $('#fzq_del_dept_form').submit();
            }
        }
    }

    function fzq_check_number(selector, label)
    {
        var qm = $(selector).val();

        //alert("qm="+qm+", nan:"+isNaN(qm));

        if (qm == "" || isNaN(qm))
        {
            alert(label);

            $(selector).focus();

            return false;
        }

        return qm;
    }

    function fzq_check_tarif(suffix, num)
    {
        var maxi = fzq_check_number("[name=quantite_maxi"+suffix+"]:eq("+num+")", "<?php echo $adm->labels['err_val_maxi']; ?>");

        if (! maxi) return false;

        if (fzq_check_number("[name=tarif"+suffix+"]:eq("+num+")", "Indiquez un tarif valide.")
            &&
            fzq_check_number("[name=surcout_unitaire"+suffix+"]:eq("+num+")", "<?php echo $adm->labels['err_surcout']; ?>")
            )
        {
            if ($("[name=id_zone_data"+suffix+"]:eq("+num+")").val() == -1)
            {
                alert("Choisissez une zone");
                $("[name=id_zone_data"+suffix+"]:eq("+num+")").focus();
            }
            else
            {
                return true;
            }
        }

        return false;
    }

    function fzq_add_tarif()
    {
        if (fzq_check_tarif("_new", 0))
        {
        	$('#tarifs').load(ajax_tarifs_url + "?_fzq_command=tarif.new&" + $('#fzq_data_form').serialize());
        }
    }

    function fzq_delete_tarif(id_data)
    {
        if (confirm("Supprimer ce tarif ?"))
        {
         	$('#tarifs').load(ajax_tarifs_url + "?_fzq_command=tarif.delete&_fzq_id_data=" + id_data);
        }
    }

    function fzq_maj_tarifs()
    {
        var n = $("[name=quantite_maxi]").length;

        var ok = true;

        for (var idx = 0; idx < n && ok; idx ++) ok = fzq_check_tarif("", idx);

        if (ok)
        {
        	$('#tarifs').load(ajax_tarifs_url + "?_fzq_command=tarif.change&" + $('#fzq_data_form').serialize());
        }
    }


    function fzq_test_tarif()
    {
        if (fzq_check_number("[name=test_quantite]", "Indiquez un nombre valide."))
        {
            if ($('[name=test_departement]').val() == '')
            {
                alert("indiquez un numéro de département.");
                $('[name=test_departement]').focus();
            }
            else
            {
            	$('#test').load(ajax_test_url + "?_fzq_command=tarif.test&" + $('#fzq_test_form').serialize());
            }
        }

        return false;
    }


    function fzq_mode_calcul()
    {
        $("#fzq_def_command").val("mode_calcul.change");

        $('#fzq_form').submit();
    }


    $(document).ready(function() {

		$('#tarifs').ajaxError(function(e, xhr, settings, exception) {
			var msg = "Echec au chargement Ajax de "+settings.url+". Erreur: " + xhr.status + " " + xhr.statusText + ". Vérifier les autorisation d'accès à ce fichier.";

			alert(msg);

			$('#tarifs').html('<p style="padding: 20px; font-weight: bold; color: #f00">' + msg + '</p>');
		});

        $('#tarifs').load(ajax_tarifs_url);
        $('#test').load(ajax_test_url);
    })
</script>

<div id="contenu_int">

	<p class="geneva11Reg_3B4B5B">
		<a href="accueil.php" class="lien04">Accueil</a>
		<img src="gfx/suivant.gif" width="12" height="9" border="0" />
		<a href="module_liste.php" class="lien04">Modules</a>
		<img src="gfx/suivant.gif" width="12" height="9" border="0" />
		<a href="module.php?nom=<?php echo ForfaitZoneQuantite::MODULE_NAME ?>" class="lien04">Forfait par zone et quantité V<?php echo ForfaitZoneQuantite::VERSION; ?></a>
	</p>

	<a name="zones"></a>

	<form action="<?php echo $_SERVER['PHP_SELF'] ?>#zones" id="fzq_form">
		<input type="hidden" name="nom" value="<?php echo ForfaitZoneQuantite::MODULE_NAME ?>" />
		<input type="hidden" name="_fzq_id_zone" value="<?php echo $adm->id_zone; ?>" />
		<input type="hidden" name="_fzq_command" id="fzq_def_command" value="create_or_update" />

		<div id="bloc_description" style="width: 100%">

			<div style="float: left; width: 450px;">
				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr>
						<th colspan="2">
						<div class="entete_liste">
							<div class="titre">PARAMETRES</div>
							<div class="fonction_valider"><a onclick="fzq_mode_calcul(); return_false;" href="#">VALIDER</a></div>
						</div>
						</th>
					</tr>
					<tr>
						<td class="cellule_claire">Calculer avec</td>
						<td class="cellule_sombre">
						<input type="radio" name="fzq_mode_calcul" value="quantite" <?php echo $adm->type_calcul == 'quantite' ? 'checked="checked"' : ''; ?> />
							Le nombre d'articles dans le panier<br />
						<input type="radio" name="fzq_mode_calcul" value="poids" <?php echo $adm->type_calcul == 'poids' ? 'checked="checked"' : ''; ?> />
							Le poids du panier (en Kg)<br />
						<input type="radio" name="fzq_mode_calcul" value="prix" <?php echo $adm->type_calcul == 'prix' ? 'checked="checked"' : ''; ?> />
							Le prix total du panier (en Euros)<br />
						</td>
					</tr>
					<tr>
						<td class="cellule_claire">Tarif par défaut</td>
						<td class="cellule_sombre">
							<input type="text" size="5" name="fzq_valeur_defaut" value="<?php echo $adm->get_variable('fzq_valeur_defaut'); ?>" /> &euro;
							<div style="font-size: 0.85em; font-style: italic;">Tarif retourné si les frais de port ne peuvent être déterminés.</div>
						</td>
					</tr>
				</table>

				<table cellpadding="0" cellspacing="0" border="0" width="100%">
					<tr>
						<th colspan="3">
						<div class="entete_liste">
							<div class="titre">ZONES EXISTANTES</div>
							<div class="fonction_valider"><a onclick="fzq_new_zone(); return_false;" href="#">+ NOUVELLE ZONE</a></div>
						</div>
						</th>
					</tr>

					<tr>
						<th class="fzq">Nom</th>
						<th class="fzq">Départements</th>
						<th class="fzq">Actions</th>
					</tr>
					<?php $idx = 0;
					foreach ($adm->zones as $zone)
					{
						$class = "cellule_" . ( ($idx++ % 2) == 0 ? "claire" : "sombre");
						?>

					<tr>
						<td nowrap="nowrap" class="<?php echo($class); ?>"><?php echo $zone['nom']; ?></td>
						<td class="<?php echo($class); ?>"><?php echo $zone['departements']; ?></td>
						<td class="<?php echo($class); ?>"><a href="#"
							onclick="fzq_prepare_update(<?php echo $zone['id']; ?>); return false;">MODIFIER</a>&nbsp;&bull;&nbsp;<a
							href="#"
							onclick="fzq_delete(<?php echo $zone['id']; ?>); return false;">SUPPRIMER</a></td>
					</tr>
					<?php } ?>
				</table>
			</div>

			<table cellpadding="0" cellspacing="0" border="0"
				style="float: right; width: 510px;">
				<tr>
					<th colspan="3">
					<div class="entete_liste">
						<div class="titre"><?php echo ($adm->id_zone != -1 ? "MODIFIER UNE ZONE" : "NOUVELLE ZONE"); ?></div>
						<div class="fonction_valider"><a onclick="fzq_submit(); return false;"href="#">VALIDER</a></div>
					</div>
					</th>
				</tr>

				<tr>
					<td colspan="3" class="cellule_sombre">Nom de la zone: <input
						type="text" style="width: 250px;" name="_fzq_nom_zone"
						value="<?php echo $adm->zones[$adm->id_zone]['nom']; ?>" ;/></td>
				</tr>

				<tr>
					<th class="fzq">Departements disponibles</th>
					<th class="fzq">&nbsp;</th>
					<th class="fzq">Départements dans la zone</th>
				</tr>

				<tr>
					<td class="cellule_claire"><select style="width: 200px;"
						multiple="multiple" size="10" name="_fzq_dept_dispos"
						id="depts_dispos">
						<?php foreach ($adm->depts_dispo as $dept) { ?>
						<option value="<?php echo($dept['id']); ?>"><?php echo($dept['id'].'-'.$dept['nom']); ?></option>
						<?php } ?>
					</select></td>

					<td class="cellule_claire"><input type="submit" name="_fzq_add"
						value="Ajouter &gt;&gt;"
						onclick="fzq_select_copy('#depts_dispos', '#dept_zone'); return false;" />
					<br />
					&nbsp;<br />
					<input type="submit" name="_fzq_del" value="&lt;&lt; Retirer"
						onclick="fzq_select_copy('#dept_zone', '#depts_dispos'); return false;" />
					</td>

					<td class="cellule_claire"><select style="width: 200px;"
						multiple="multiple" size="10" name="_fzq_dept_zone[]" id="dept_zone">
						<?php foreach ($adm->depts_zone as $dept) { ?>
						<option value="<?php echo($dept['id']); ?>"><?php echo($dept['id'].'-'.$dept['nom']); ?></option>
						<?php } ?>
					</select></td>
				</tr>
			</table>
		</div>
	</form>

	<form action="<?php echo $_SERVER['PHP_SELF'] ?>#zones" id="fzq_dept_form">
		<input type="hidden" name="nom" value="<?php echo ForfaitZoneQuantite::MODULE_NAME ?>" />
		<input type="hidden" name="_fzq_command" id="fzq_dept_command" value="create_dept" />

		<table cellpadding="0" cellspacing="0" border="0"
			style="float: right; width: 510px; margin-top: 10px;">
			<tr>
				<th colspan="2">
				<div class="entete_liste">

				<div class="titre">AJOUTER UN DEPARTEMENT</div>
				<div class="fonction_valider"><a
					onclick="fzq_dept_submit(); return false;" href="#">VALIDER</a></div>
				</div>
				</th>
			</tr>

			<tr>
				<td class="cellule_sombre">Code postal</td>
				<td class="cellule_claire"><input type="text" maxlength="10"
					style="width: 50px;" name="_fzq_id_departement" /></td>
			</tr>
			<tr>
				<td class="cellule_sombre">Libellé</td>
				<td class="cellule_claire"><input type="text" style="width: 250px;"
					name="_fzq_nom_departement" /></td>
			</tr>
		</table>
	</form>

	<form action="<?php echo $_SERVER['PHP_SELF'] ?>#zones" id="fzq_del_dept_form">
		<input type="hidden" name="nom" value="<?php echo ForfaitZoneQuantite::MODULE_NAME ?>" />
		<input type="hidden" name="_fzq_command" id="fzq_del_dept_command" value="delete_dept" />

		<table cellpadding="0" cellspacing="0" border="0"
			style="float: right; width: 510px; margin-top: 10px;">
			<tr>
				<th colspan="2">
					<div class="entete_liste">
						<div class="titre">SUPPRIMER DES DEPARTEMENTS</div>
						<div class="fonction_valider"><a onclick="fzq_del_dept_submit(); return false;" href="#">SUPPRIMER</a></div>
					</div>
				</th>
			</tr>

			<tr>
				<td class="cellule_sombre">Supprimer un département</td>
				<td class="cellule_claire"><select style="width: 200px;"
					name="_fzq_del_dept" id="del_dept">
					<?php foreach ($adm->depts_tous as $dept) { ?>
					<option value="<?php echo($dept['id']); ?>"><?php echo($dept['id'].'-'.$dept['nom']); ?></option>
					<?php } ?>
				</select></td>
			</tr>

			<tr>
				<td class="cellule_sombre">Supprimer TOUS les départements</td>
				<td class="cellule_claire"><input type="checkbox"
					name="_fzq_delete_all" value="1"></td>
			</tr>
		</table>
	</form>

	<br style="clear: both" />

	<div id="tarifs">Chargement en cours...</div>

	<div id="test">Chargement en cours...</div>

	<p style="clear: both; margin-top: 30px;color:#505050;font-size:9px;text-align:left;">Plugin Thelia réalisé par <a href="http://www.cqfdev.fr" target="_blank">Franck Allimant / CQFDev</a>. Contact: <a href="http://www.cqfdev.fr" target="_blank">www.cqfdev.fr</a></p>

</div>
